% dvehmoty.m ... program k prikladu na kmitani se dvema stupni volnosti

clear all
close all
format compact

global F0 om k1 k2 m1 m2 B

% Zadane hodnoty
m1=3.1
m2=1.6
k1=2000
k2=1000
F0=14
om=6
                  
% pocatecni podminky
y0=[-0.002;
     0.004]
y0dot=[0;
        0]
% Matice hmotnosti
M=[m1  0;
    0 m2];
% Matice tuhosti
K=[ k1   -k1;
   -k1 k1+k2];
% Amplituda budici sily
f0=[F0;
     0];

% Vlastni tvary a frekvence
[V,OM]=eig(K,M);
OM1=sqrt(OM(1,1))
OM2=sqrt(OM(2,2))
 
% % % % ukazka vybuzeni vlastnich tvaru
% % % t=0:0.01:2; % definujeme si nejaky casovy usek
% % % % pocatecni vychylky v pomeru 1. vl.tvaru
% % % A1=inv(V)*[0.05*V(1,1); 0.05*V(2,1)]
% % % B1=inv(V*sqrt(OM))*[0; 0]
% % % % ... a napocteme prubeh vychylek
% % % y1=A1(1)*V(1,1)*cos(OM1*t)+B1(1)*V(1,1)*sin(OM1*t)+A1(2)*V(1,2)*cos(OM2*t)+B1(2)*V(1,2)*sin(OM2*t);
% % % y2=A1(1)*V(2,1)*cos(OM1*t)+B1(1)*V(2,1)*sin(OM1*t)+A1(2)*V(2,2)*cos(OM2*t)+B1(2)*V(2,2)*sin(OM2*t);
% % % figure      % zalozi novy obrazek
% % % plot(t,y1,'b',t,y2,'r')   % vykresleni prubehu
% % % title('Vybuzeni 1. vlastniho tvaru pocatecnimi vychylkami')
% % % xlabel('cas [s]'), ylabel('vychylka [rad]')
% % % legend('y1(t)','y2(t)')
% % % 
% % % t_1_tvar=t;
% % % y1_1_tvar=y1;
% % % y2_1_tvar=y2;
% % % 
% % % % pocatecni rychlosti v pomeru 2. vl.tvaru
% % % A2=inv(V)*[0; 0]
% % % B2=inv(V*sqrt(OM))*[2*V(1,2); 2*V(2,2)]
% % % % ... a napocteme prubeh vychylek
% % % y1=A2(1)*V(1,1)*cos(OM1*t)+B2(1)*V(1,1)*sin(OM1*t)+A2(2)*V(1,2)*cos(OM2*t)+B2(2)*V(1,2)*sin(OM2*t);
% % % y2=A2(1)*V(2,1)*cos(OM1*t)+B2(1)*V(2,1)*sin(OM1*t)+A2(2)*V(2,2)*cos(OM2*t)+B2(2)*V(2,2)*sin(OM2*t);
% % % figure      % zalozi novy obrazek
% % % plot(t,y1,'b',t,y2,'r')   % vykresleni prubehu
% % % title('Vybuzeni 2. vlastniho tvaru pocatecnimi rychlostmi')
% % % xlabel('cas [s]'), ylabel('vychylka [rad]')
% % % legend('y1(t)','y2(t)')
% % % 
% % % t_2_tvar=t;
% % % y1_2_tvar=y1;
% % % y2_2_tvar=y2;
% % % 
% % % pause
% % % % animace
% % % figure
% % % for i=1:length(t_1_tvar)
% % %     plot(0,y1_1_tvar(i),'rs','linewidth',8); hold on
% % %     plot(0,y2_1_tvar(i)-0.02,'rs','linewidth',8); 
% % %     plot([0,0],[0.04,y1_1_tvar(i)],'r','linewidth',(0.04+y1_1_tvar(i))*100);
% % %     plot([0,0],[y1_1_tvar(i),y2_1_tvar(i)-0.02],'r','linewidth',(y1_1_tvar(i)+y2_1_tvar(i)+0.05)*100);
% % %     axis([-1 1 -0.06 0.04]);
% % %     pause(0.01)
% % %     hold off
% % %     drawnow
% % % end
% % % 
% % % pause
% % % figure
% % % for i=1:length(t_2_tvar)
% % %     plot(0,y1_2_tvar(i),'bs','linewidth',8); hold on
% % %     plot(0,y2_2_tvar(i)-0.05,'bs','linewidth',8); 
% % %     plot([0,0],[0.04,y1_2_tvar(i)],'b','linewidth',(0.04+y1_2_tvar(i))*100);
% % %     plot([0,0],[y1_2_tvar(i),y2_2_tvar(i)-0.05],'b','linewidth',(y1_2_tvar(i)+y2_2_tvar(i)+0.05)*100);
% % %     axis([-1 1 -0.09 0.04]);
% % %     pause(0.01)
% % %     hold off
% % %     drawnow
% % % end
% % % 
% % % 

% nastaveni delky experimentu (s)
tstart=0;
tkonec=4;

% nastaveni maximalni velikosti kroku pri integraci
options=odeset('MaxStep',0.001);

[t,z]=ode45(@zdot,[tstart:0.001:tkonec],[y0(1),y0dot(1),y0(2),y0dot(2)],options);
 
% vykresleni
figure      % zalozi novy obrazek
plot(t,z(:,1),'b',t,z(:,3),'r')   % vykresleni prubehu
title('Celkove reseni pro zadane obecne pocatecni podminky')
xlabel('cas [s]'), ylabel('vychylka [rad]')
legend('y1(t)','y2(t)')

% vypocet amplitud vynucenych kmitu v zavislosti na menicim se omega
r=[];   % pripravim si prazdne pole, do ktereho budu ukladat r jako funkci omega
omega=0:0.1:80;
for i=1:1:length(omega)
    r=[r, inv(K-omega(i)^2*M)*f0];
end
% vykresleni
figure
plot(omega, r(1,:),'b.',omega, r(2,:),'r.')
axis([0 omega(length(omega)) -0.2 0.2])   % upravuji si osy na obrazku, protoze pri rezonanci utikaji amplitudy k nekonecnu 
grid on
title('Amplitudove charakteristiky')
xlabel('omega [1/s]'), ylabel('vychylka [rad]')
legend('r1','r2')

% transformace do modalnich souradnic
disp('V''*M*V Pokud je spravne normovano, mela by vyjit jednotkova matice:')
V'*M*V

disp('V''*K*V Tady matice vlastnich frekvenci na druhou (OM):')
V'*K*V
OM

% Rayleighovo tlumeni
br1=0.02;
br2=0.02;

P=[1, OM1^2;
   1, OM2^2];
Q=[2*br1*OM1;
   2*br2*OM2]; 
koeficienty=inv(P)*Q;
alfa=koeficienty(1);
beta=koeficienty(2);
B=alfa*M + beta*K

% nastaveni maximalni velikosti kroku pri integraci
options=odeset('MaxStep',0.001);

[t,z]=ode45(@zdot_s_tlumenim,[tstart:0.001:tkonec],[y0(1),y0dot(1),y0(2),y0dot(2)],options);
 
% vykresleni
figure      % zalozi novy obrazek
plot(t,z(:,1),'b',t,z(:,3),'r')   % vykresleni prubehu
title('Celkove reseni s tlumenim pro zadane obecne pocatecni podminky')
xlabel('cas [s]'), ylabel('vychylka [rad]')
legend('y1(t)','y2(t)')